import MuseScore 3.0
import QtQuick 2.9
import QtQuick.Controls 2.2
import QtWebEngine 1.5
import QtWebChannel 1.0
import Qt.labs.settings 1.0
MuseScore {
  menuPath: "Plugins.Makeshift REPL"
  version: "230207A"
  pluginType: "dock"
  anchors.fill: parent
  implicitHeight: 9999
  id:pluginscope 
  Component.onCompleted:{
    settings.repl=settings.repl||'\
\/*WARNING:\n\
  Backup scores NOW, BEFORE clicking this area,\n\
this plugin uses eval() and is unstable.\n\
  Closing (and reopening) this window creates \n\
duplicate background components that hoard RAM and \n\
CRASH WINDOWS, restart Musescore to close them.\n\
*\/\n\
clearlog();log(Date())'
    if (mscoreMajorVersion >= 4) {
      pluginscope.title = menuPath.replace('Plugins.','')
      // some_id.thumbnailName = "thumbnail.png";
      // some_id.categoryCode = "some_caregory";
    }
  }
  QtObject { id: backendobj; WebChannel.id: "backendid"
    signal post(string payload)
    function log(x){backendobj.post(JSON.stringify({msg:''+x}))}
    function loge(x){backendobj.post(JSON.stringify({msg:eval('"'+x+' "+'+x)}))}
    function clearlog(x){backendobj.post(JSON.stringify({clear:true}))}
    function backf(x){
      var y=JSON.parse(x).msg
      try{ eval(y) }catch(e){ log('EvalError : '+e) }
      settings.repl=y 
    }
  }
  WebChannel { id: channel; registeredObjects: [backendobj] }
  WebEngineView { id : wv; webChannel: channel; url : "MakeshiftREPL.html"
    anchors.fill: parent
    // focus:true
    // KeyNavigation.tab: this
    onContextMenuRequested: request.accepted = true //disable right click menu
    onLoadingChanged: { if(loadRequest.status === WebEngineView.LoadSucceededStatus) runJavaScript("input.value=`"+settings.repl+"`;setinputvalue(`"+settings.repl+"`)") }
    onJavaScriptConsoleMessage: function(w,s,l,i){ console.log('WV console line '+l+' : '+s) }
  }
  Settings{
    id:settings
    category: menuPath.replace(/[\.\s]/g,'')
    property string repl
  }
}